import java.awt.Color;

/*ghassan fakher
 * section 6
 gkf01*/

public class Turtle {
	private double x;
	private double y;
	private double angle;
	public Turtle(double x0, double y0, double a0)
	{
		angle = a0;
		x = x0;
		y = y0;
	}
	public void turnLeft(double delta)
	{
		angle += delta;
	}
	public void goForward(double step)
	{
		double oldX = x;
		double oldY = y;
		x += step * Math.cos(Math.toRadians(angle));
		y += step * Math.sin(Math.toRadians(angle));
		boundaryExceptions();
		StdDraw.line(oldX, oldY, x, y);
	}
	public void setColor(Color c){
		StdDraw.setPenColor(c);
	}
	private void boundaryExceptions(){
	//added .1 to the upper and right boundaries and subtraced .1 from the lower and left boundaries
	//(1.1 and -0.1) because our canvas is set to be 10% more of its expected size.
		if(x > 1.1 && y > 1.1)
			throw new RuntimeException("The picture went out of the right upper boundary");
		else if(y > 1.1 && x < -.1)
			throw new RuntimeException("The picture went out of the left upper boundary");
		else if(x > 1.1 && y < -.1)
			throw new RuntimeException("The picture went out of the right lower boundary");
		else if(y < -.1 && x < -.1)
			throw new RuntimeException("The picture went out of the left lower boundary");	
		else if(x > 1.1)
			throw new RuntimeException("The picture went out of the right boundary");
		else if(y > 1.1)
			throw new RuntimeException("The picture went out of the upper boundary");
		else if(x < -0.1)
			throw new RuntimeException("The picture went out of the left boundary");
		else if(y < -0.1)
			throw new RuntimeException("The picture went out of the lower boundary");		
	}
}
