/*ghassan fakher
 * gkf01
 section 6*/
public class Line {
	private Point point1; 
	private Point point2;
	public Line(Point p1, Point p2)
	{
		point1 = p1;
		point2 = p2;
	}
	public Line(int x1, int y1, int x2, int y2)
	{
		point1 = new Point(x1, y1);
		point2 = new Point(x2, y2);
	}
	public Point getP1()
	{
		return point1;
	}
	public Point getP2()
	{
		return point2;
	}
	public String toString()
	{
		return("[( " + point1.getX() + " , " + point1.getY() + " ) , ( " +  + point2.getX() + " , " + point2.getY() + " )]");
	}
	public double getSlope()
	{
		if(point1.getX() != point2.getX())
		{
			return ((point1.getY() - point2.getY()) * 1.0 / (point1.getX() - point2.getX()));	//the slope
		}
		else
		{
			throw new IllegalArgumentException("No such slope; difference of the two abssicas gives a zero denomenator");
		}
	}
	
	public boolean isCollinear(Point p)
	{
		boolean isCollinear = false;
		double slope1 = 0;
		if((p.getY() == point1.getY() && p.getX() == point1.getX()) || (p.getX() == point2.getX() && p.getX() == point2.getX()))
		{
			isCollinear = true;
		}
		else
		{
			slope1 = (p.getY() - point1.getY()) / (p.getX() - point1.getX()) * Math.pow(10, -4);
		}
		double slope2 = getSlope() * Math.pow(10, -4);		
		if(slope1 == slope2 && isCollinear == false)
		{
			isCollinear = true;
		}
		return isCollinear;
	}
}
